package test.mapplet;

import java.io.InputStream;
import java.io.PrintStream;
import java.io.IOException;
import java.applet.Applet;
import java.awt.TextArea;
import java.awt.Choice;
import java.awt.Label;
import java.awt.Button;
import java.awt.Panel;
import java.awt.Frame;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

public class Game extends Applet
{
  public static final int MAXDIGNO = 4;
  public static final int IDLE = 0;
  public static final int PLAYING = 1;

  CombCellType cell_;
  int state_, nth;
  MasterMind mm;

  TextArea qtf_;
  Choice fixedtf_, floppytf_;
  Button button_;

  public void init()
    {
      state_ = IDLE;
      mm = new MasterMind();
      setLayout(new FlowLayout());
      qtf_ = new TextArea("", 15, 40, TextArea.SCROLLBARS_NONE);
      qtf_.setEditable(false);

      fixedtf_ = new Choice();
      fixedtf_.add("0");
      fixedtf_.add("1");
      fixedtf_.add("2");
      fixedtf_.add("3");
      fixedtf_.add("4");

      floppytf_ = new Choice();
      floppytf_.add("0");
      floppytf_.add("1");
      floppytf_.add("2");
      floppytf_.add("3");
      floppytf_.add("4");

      button_ = new Button("Restart");

      Label 
	fix = new Label("Fixed"), 
	flop = new Label("Floppy"), 
	digits = new Label("Digits"),
	dummy1 = new Label(),
	dummy2 = new Label();

      Panel control = new Panel(new GridLayout(4, 2));
      control.add(dummy1);
      control.add(digits);
      control.add(fix);
      control.add(fixedtf_);
      control.add(flop);
      control.add(floppytf_);
      control.add(dummy2);
      control.add(button_);

      add(control);
      add(qtf_);

      button_.addActionListener(new BListener());
    }

    void displayGuess(int fixed, int floppy)
    {
      String question = "";
      if ( fixed >= 0 )
        question = question + "   fixed: " + fixed + "   floppy: " + floppy
	+ "\n";
      cell_ = mm.getGuess();
      question = question + nth++ + ". I try ";
      for(int i = 1; i <= MAXDIGNO; i++)
	question = question + cell_.comb_[i];
      qtf_.append(question);
    }

  public static void main(String[] args) throws IOException
    {
      Game g = new Game();
      Frame frame = new Frame();
      frame.add(g);
      g.init();
      frame.setVisible(true);
    }


  class BListener implements ActionListener
  {
    public void actionPerformed(ActionEvent e)
      {
	if(state_ == IDLE)
	  {
	    qtf_.setText("");
	    mm.restart();
	    nth = 1;
	    displayGuess(-1, -1);
	    button_.setLabel("Next");
	    state_ = PLAYING;
	  }
	else
	  {
	    int fixed = fixedtf_.getSelectedIndex();
	    int floppy = floppytf_.getSelectedIndex();
	  
	    int combsNo = mm.cutCombs(fixed, floppy, cell_);
	    String answer;

	    switch(combsNo)
	      {
	      case 0:
		{
		  answer = "You fed me with some wrong answers. Liar!";

		  qtf_.append("\n" + answer + "\n");
		  state_ = IDLE;
		  button_.setLabel("Restart");
		  break;
		}
	      case 1:
		{
		  cell_ = mm.getAnswer();
		  answer = "Your combination is: ";
		  for(int i = 1; i <= MAXDIGNO; i++)
		    answer = answer + cell_.comb_[i];

		  qtf_.append("\n" + answer + "\n");
		  state_ = IDLE;
		  button_.setLabel("Restart");
		  break;
		}
	      default:
		  displayGuess(fixed, floppy);
	      }
	  }
      }
  }
}

