package test.mapplet;

import java.io.InputStream;
import java.io.PrintStream;

public class MasterMind 
{
  public final int 
      MAXDIGNO = 4,
      MAXCOMB  = 9*8*7*6+1, // Arrangements of 9 in groups of 4 
      MAXDIG   = 10,
      NULL     = 0,
      maxint   = 0x7FFFFFFF;
  
  CombCellType[] list_ = new CombCellType[MAXCOMB + 1];
  int remainingCombs_;

  public MasterMind()
    {
      for(int i = 0; i <= MAXCOMB; list_[i++] = new CombCellType());
    }

  public void restart()
    {
      int i, j, number;
      boolean CombOk;
      boolean[] digits = new boolean[MAXDIG];


      for(i = 0; i < MAXDIG; i++)
	digits[i]=false;

      remainingCombs_ = 1;

      for(i = 1; i<= MAXDIG*MAXDIG*MAXDIG*MAXDIG; i++)
	{
	  number = i;
	  CombOk = true;
	  for(j = 1; j <= MAXDIGNO; j++)
	    {
	      list_[remainingCombs_].comb_[j] = number % MAXDIG;
	      number = number / MAXDIG;
	      CombOk = (CombOk &&
			(list_[remainingCombs_].comb_[j] != 0) &&
			!digits[list_[remainingCombs_].comb_[j]]);
	      digits[list_[remainingCombs_].comb_[j]] = true;
	    }
	  for(j = 1; j <=  MAXDIGNO; j++)
	    digits[list_[remainingCombs_].comb_[j]] = false;
	  if(CombOk)
	    {
	      list_[remainingCombs_ - 1].next = remainingCombs_;
	      remainingCombs_++;
	    }
	}
      remainingCombs_--;
      list_[remainingCombs_].next = NULL;
    }

  boolean NotOk(int c1[], int c2[], int fixed, int floppy)
    {
      int i,j,fix,flop;
      
      fix = 0; flop = 0;
      for(i = 1; i <= MAXDIGNO; i++)
	for(j = 1; j <= MAXDIGNO; j++)
	  if(c1[i] == c2[j])
	    if(i == j)
	      fix = fix + 1;
	    else
	      flop = flop + 1;
      return ((fixed != fix) || (floppy != flop));
    }
  
  int random(int n)
    {
      return (int)(Math.random() * n);
    };
  

  int cutCombs(int fixed, int floppy, CombCellType cell)
    {
      int n = 0, prev = 0, curr = list_[0].next;
      while(curr != NULL)
	{
	  if(NotOk(list_[curr].comb_, cell.comb_, fixed, floppy))
	    list_[prev].next = list_[curr].next;
	  else
	    {
	      prev = list_[prev].next;
	      n = n+1;
	    }
	  curr = list_[curr].next;
	}
      return remainingCombs_ = n;
    }

  CombCellType getGuess()
    {
      int nth = random(remainingCombs_), guess = 0;
      for(int i = 0; i <= nth; i++)
	guess = list_[guess].next;
      list_[guess].comb_[0] = remainingCombs_;
      return list_[guess];
    }

  CombCellType getAnswer()
    {
      return list_[list_[0].next];
    }
}
